/******************************************************************************

  (c) 2004-2012 Scientific Computation Research Center,
      Rensselaer Polytechnic Institute. All rights reserved.

  The LICENSE-SCOREC file included with this distribution describes the terms
  of the SCOREC Non-Commercial License this program is distributed under.

*******************************************************************************/
#include "FMDB.h"

int FMDB_Ent_GetAdjPtnObj (pMeshEnt ent, std::vector<pPtnObj>& adjPtnObj)
{
  std::set<mAttachableDataContainer*> adjPO;
  ent->getAdjPtnObj (adjPO);
  std::copy (adjPO.begin(), adjPO.end(), std::back_inserter(adjPtnObj));
}

int FMDB_PtnObj_GetType (pPtnObj ptn_obj, int* type)
{
  if (ptn_obj->getContainerType()==mAttachableDataContainer::ENTITY)
  {
    if (((mEntity*)ptn_obj)->getLevel()==3)
      *type = FMDB_REGION;
    else 
      *type = FMDB_FACE;
  }
  else
    *type = FMDB_PSET;
  return SCUtil_SUCCESS;
}

