/****************************************************************************** 

  (c) 2004-2012 Scientific Computation Research Center, 
      Rensselaer Polytechnic Institute. All rights reserved.
  
  The LICENSE-SCOREC file included with this distribution describes the terms
  of the SCOREC Non-Commercial License this program is distributed under.
 
*******************************************************************************/
#ifndef _MENTITYGROUP_H_
#define _MENTITYGROUP_H_

#include <set>
#include <vector>

#include "mAttachableDataContainer.h"
#include "mFMDB.h"
#include "mEntitySet.h"

using std::set; 
using std::vector; 

  class mEntity;

  class mEntityGroup : public EntitySetUnordered<mEntity> 
  {
  public: 
   typedef std::list<mEntity*>::iterator entIter; 
    mEntityGroup(int);
    ~mEntityGroup(); 

    void addEntity(mEntity* ent); 
    void addEntity(mEntity* ent, int pos);
    void removeEntity(mEntity* ent);
    void clear();

    mEntity* getEntity(int pos);
    int getEntityOrder(mEntity* ent);
    conType getContainerType() const {return PSET; }
    void getNumEntity(int* numV, int* numE, int* numF, int* numR);
#ifdef FMDB_PARALLEL
    set<void*>* bdryEnts; 

    void computeBdryEntities(); 
    void removeBdryEntities(); 
    int  numBdryEntities() {if(bdryEnts==NULL) return 0;  return bdryEnts->size(); }
#endif

    void print(); 

  }; 
#endif

