/****************************************************************************** 

  (c) 2004-2012 Scientific Computation Research Center, 
      Rensselaer Polytechnic Institute. All rights reserved.
  
  The LICENSE-SCOREC file included with this distribution describes the terms
  of the SCOREC Non-Commercial License this program is distributed under.
 
*******************************************************************************/
#ifndef _H_MESHIO_
#define _H_MESHIO_
#include "FMDB.h"
#include "mPart.h"
int importSMS(mMesh *, const char *);
int importVTK (mMesh *, const char *);
int importNCDF(mPart* mesh, const char *fname, int mid_flag=-1);
#ifdef NCDF64
int importNCDFBin(mPart* mesh, const char *fname, int mid_flag=-1);
#endif/*NCDF64*/
int exportSMS (mMesh *, const char*);
int exportVTK(mPart *, const char* fname, int partId=-1);
int exportNCDF(mPart*, pGModel, const char *, const char *);
#ifdef NCDF64
int exportNCDFBin(mPart* , pGModel, const char *, const char *);
#endif/*NCDF64*/

#ifdef FMDB_PARALLEL
  int import_serial_and_partition_SMS(const char *, mMesh*, pmMigrationCallbacks &lb);
  int import_parallel_singlepart_SMS(mMesh*,const char*);
  int import_parallel_multipart_SMS(mMesh*,const char*);
#endif

int exportMeshToSMS(pMeshMdl,const char*);
int exportMeshToVTK (pMeshMdl, const char*);

int exportTagsToVTK(pMeshMdl mesh, vector<pMeshEnt> const& taggedEnt, FILE* outFile);
/// Function for writing out a part of a mesh in vtu format
int write_3Dpart_vtu(pMeshMdl mesh, const char* fname, vector<pRegion> &regs);
int write_3Dpart_vtu(pMeshMdl mesh, const char* fname, vector<pRegion> &regs, vector<pTag>& rgnTagsToWrite, vector<pTag>& vtxTagsToWrite);
#endif
