/****************************************************************************** 

  (c) 2004-2012 Scientific Computation Research Center, 
      Rensselaer Polytechnic Institute. All rights reserved.
  
  The LICENSE-SCOREC file included with this distribution describes the terms
  of the SCOREC Non-Commercial License this program is distributed under.
 
*******************************************************************************/
#ifdef FMDB_PARALLEL

#include <iostream>
#include "pmGraph.h"
#include "pmUtility.h"
#include "pmMigration.h"
#include "mPart.h"
#include "mEntity.h"
#include "pmMigrationCallbacks.h"
#include "ParUtil.h"
#include "mFMDB.h"

#include "pmDataExchanger.h"

#include <stdio.h>
#include <algorithm>
#include <map>

using namespace std;

  class idExchanger : public pmDataExchanger
  {
    int from,to;
    unsigned int tagId;
    unsigned int tagDn;
    unsigned int tagAtt1; 
  public :
    idExchanger(int f, int t):from(f),to(t), 
                             tagId(FMDB_Util::Instance()->getId()),
			      tagDn(FMDB_Util::Instance()->getDn()),
			      tagAtt1(FMDB_Util::Instance()->getCheckMark())   
    {}
    virtual int msg_size();
    virtual void fill_buffer (mEntity *e, int, int, mEntity*remoteEnt, void *&msg_send);
    virtual void receiveData (void *msg_recv, int pid_from);
  };

  int idExchanger :: msg_size()
  {
    return sizeof(int) + sizeof(mEntity*);
  }

  void idExchanger:: fill_buffer (mEntity *e, int src, int dest, mEntity* remoteEnt, void *&msg_send)
  {
  }

  void idExchanger::receiveData (void *msg_recv, int pid_from)
  {
    mEntity** s_ent = (mEntity**)msg_recv;
    int *s_id = (int*)((char*)msg_recv + sizeof(mEntity*));    
    (*s_ent)->attachInt(tagDn, *s_id);
    if((*s_ent)->getAttachedInt(tagDn) != *s_id)throw;
    if(pid_from != 0)
      (*s_ent)->attachInt(tagAtt1, pid_from);
    else 
      (*s_ent)->attachInt(tagAtt1,-1);
  }
 
  FMDB_distributed_graph2::FMDB_distributed_graph2(mPart *m, int from, int to,
						   pmMigrationCallbacks *dm,
						   int level)  
  {
  }


  void FMDB_distributed_graph2 :: print(ostream &o)
  {
    printf("on processor %d :\n",ParUtil::Instance()->rank());
    theGraph->print(o);
    o << "vtxdist : ";
    for(int i=0;i<=ParUtil::Instance()->size();i++)o << vtxdist[i] << " ";
    o << "\n";
  }



  FMDB_distributed_graph2 :: ~FMDB_distributed_graph2()
  {
     delete theGraph;
     delete [] vtxdist;
  }

#endif
