/****************************************************************************** 

  (c) 2004-2012 Scientific Computation Research Center, 
      Rensselaer Polytechnic Institute. All rights reserved.
  
  The LICENSE-SCOREC file included with this distribution describes the terms
  of the SCOREC Non-Commercial License this program is distributed under.
 
*******************************************************************************/
#include "iUtil.h"
#include "mAttachableDataContainer.h"
#include "mPart.h"
#include "mEntity.h"
#include "FMDB.h"
#include <iostream>
#include <list>
#include <map>
#include <algorithm>

using namespace std;

ITAPS_Util::ITAPS_Util() {}

ITAPS_Util::~ITAPS_Util() 
{
}
ITAPS_Util* ITAPS_Util::Instance()
{
  static ITAPS_Util s;
  return &s;
}

// VALID TYPE+TOPO
// VERTEX: POINT, ALL_TOPOLOGIES
// EDGE: LINE_SEGMENT, ALL_TOPOLOGIES
// FACE: TRIANGLE, QUADRILATERAL, POLYGON, ALL_TOPOLOGIES
// REGION: TETRAHEDRON, ..., ALL_TOPOLOGIES
// ALL_TYPES: POINT, ..., ALL_TOPOLOGIES

bool checkTypeTopo(int requested_entity_type, 
                             int requested_entity_topology)
{
  switch (requested_entity_type)
  {
    // VERTEX
    case FMDB_VERTEX: if (requested_entity_topology == FMDB_POINT || 
               requested_entity_topology == FMDB_ALLTOPO)
             return true;
	   else break;    
    // EDGE
    case FMDB_EDGE: if (requested_entity_topology == FMDB_LINE || 
               requested_entity_topology == FMDB_ALLTOPO)
             return true;
	   else break;
    // FACE
    case FMDB_FACE: if (requested_entity_topology == FMDB_TRI|| 
               requested_entity_topology == FMDB_QUAD ||
	       requested_entity_topology == FMDB_POLYGON ||
               requested_entity_topology == FMDB_ALLTOPO)
             return true;
	   else break;
    // REGION
    case FMDB_REGION: if (requested_entity_topology == FMDB_TET || 
               requested_entity_topology == FMDB_PYRAMID ||
	       requested_entity_topology == FMDB_PRISM ||
	       requested_entity_topology == FMDB_HEX ||
	       requested_entity_topology == FMDB_SEPTA ||
	       requested_entity_topology == FMDB_POLYHEDRON ||
               requested_entity_topology == FMDB_ALLTOPO)
             return true;
	   else break;
    // ALL_TYPES
    default: if ((FMDB_POINT<=requested_entity_topology)&&(requested_entity_topology<=FMDB_ALLTOPO))
             return true;
	   else break;
    
  }
  return false;
}

