/******************************************************************************

  (c) 2004-2012 Scientific Computation Research Center,
      Rensselaer Polytechnic Institute. All rights reserved.

  The LICENSE-SCOREC file included with this distribution describes the terms
  of the SCOREC Non-Commercial License this program is distributed under.

*******************************************************************************/

#include "mGhost.h"

#ifdef FMDB_PARALLEL
mGhost::mGhost()
 {
   ghostStatus=-1;
   theGhostCopies=NULL;  
   tempGPs=NULL;
   ownerEnt=NULL;
 }
void mGhost::printGPs()
 {
   if(tempGPs==NULL)
      return;
   for (mGhost::GPIter gpiter=gpBegin(); gpiter!=gpEnd();++gpiter)
     cout<<*gpiter<<",";
   cout<<endl;
 }
void mGhost::printGCs()
 {
  if(theGhostCopies==NULL)
   return;
  for (mGhost::GCIter gciter=gcBegin(); gciter!=gcEnd();++gciter)
    cout<<"(P"<<gciter->first<<","<<gciter->second<<"), ";
  cout<<endl;
 }

mEntity* mGhost::getGhostCopy(int pid)
 {
  mEntity* ghostEnt = (mEntity*)0;
  if(theGhostCopies==NULL)
    return ghostEnt;

  map<int,mEntity*>::iterator mapit = theGhostCopies->find(pid);
  if (mapit!=theGhostCopies->end())
    ghostEnt = mapit->second;
  return ghostEnt;
 }

void mGhost::getGhostCopies(map<int, mEntity*>& ghostCopies)
 {
  if(theGhostCopies==NULL)
     return;
  assert(ghostCopies.empty());
  for (GCIter it=gcBegin(); it!=gcEnd(); ++it)
    ghostCopies.insert(ghostCopyMap::value_type(it->first, it->second));
 }

 void mGhost::addGhostCopy(int pid, mEntity* ghostEnt)
 {
  if(theGhostCopies==NULL)
   theGhostCopies = new ghostCopyMap;

  theGhostCopies->insert(ghostCopyMap::value_type(pid, ghostEnt));
 }

 void mGhost::deleteGhostCopy(int pid)
 {
  if(theGhostCopies==NULL)
     return;

  theGhostCopies->erase(ghostCopyMap::key_type(pid));

  if(theGhostCopies->empty())
     SAFE_DELETE(theGhostCopies);
 }

  void mGhost::deleteGhostCopy(mGhost::GCIter gciter)
  {
   if(theGhostCopies==NULL)
    return;

  theGhostCopies->erase(gciter);

  if(theGhostCopies->empty())
   SAFE_DELETE(theGhostCopies);
  }

void mGhost::clearGhostCopies()
  {
  if(theGhostCopies==NULL)
    return;

  theGhostCopies->clear();
  assert(theGhostCopies->empty());
  }
#endif
